#ifndef __DEF_H__
#define __DEF_H__

#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include <SDL/SDL_mixer.h>

typedef enum {true=1, false=0} bool;
enum {MODE_KANJI=1, MODE_ALPHA=2};
enum {SOLID=1, SHADED=2, BLENDED=3};

enum {
  PRESS_BTN_UP = 0,
  PRESS_BTN_DOWN,
  PRESS_BTN_LEFT,
  PRESS_BTN_RIGHT,
  PRESS_BTN_A,
  PRESS_BTN_B,
  PRESS_BTN_X,
  PRESS_BTN_Y,
  PRESS_BTN_L,
  PRESS_BTN_R,
  PRESS_BTN_START,
  PRESS_BTN_SELECT,
  PRESS_BTN_MAX
};

typedef struct {
  int font_size;
  int line_space;
  int line_height;
  int disp_line_max;
  int line_max;
  int bar_size;
  int text_mode;
  int rendering_func;
  char filename[200];
  char fontfile[200];
  SDL_Color fg_color;
  SDL_Color bg_color;
} global_option;

#define SCREEN_WIDTH  320
#define SCREEN_HEIGHT 240
#define SCREEN_BPP    16
#define WIDTH_MAX 312
#define HEIGHT_MAX 230

#define DEFAULT_FONT_PATH "/usr/local/share/VL-Gothic-Regular.ttf"
//#define DEFAULT_FONT_PATH "VL-Gothic-Regular.ttf"
//#define DEFAULT_FONT_PATH "mplus-2c-medium.ttf"
//#define BUF_MAX 1024
#define BUF_MAX 2048
#define LINE_MAX 120
#define LINE_NUM_MAX 30000
#define WORD_LENGTH_MAX 300
#define WORD_NUM_MAX 160
#define BOOKMARK_PATH "bookmark.txt"
#define BOOKMARK_TMP_PATH "bookmark_tmp.txt"
#define REPEAT_DELAY 30
#define REPEAT_INTERVAL 2

bool button_to_process[PRESS_BTN_MAX] = {false, false, false, false, false, false, false, false, false, false, false, false};

#endif
